/*
 * dict.c - dictionary for the bafflegab project critic.
 *
 * A criticism is of the form:
 *  "The " <truthadj> " " <probnoun> " is the " <badadj> " " <badnoun> "."
 */

char *truthadj[] = { /* a truth adjective */
    "RIY4AXLX",		/* real			*/
    "AE4KCHUWAXL",	/* actual		*/
    "BEY3SIHK",		/* basic		*/
    "KAHNSPIH2KYUWAHS",	/* conspicuous		*/
    "IYTER3NLX",	/* eternal		*/
    "FEY3TDXAXL",	/* fatal		*/
    "FAH3NDAHMEHNTAXL",	/* fundamental		*/
    "GLEH2RIYNX",	/* glaring		*/
    "IHMIY3DIYAXTDX",	/* immediate		*/
    "LIY3THAXL",	/* lethal		*/
    "AA3BVIYAHS",	/* obvious		*/
    "OH3VERWEH2LMIHNX",	/* overwhelming		*/
    "AH3NDIHNAY2AXBLX",	/* undeniable		*/
    "YUW3NIHVER2SAXL",	/* universal		*/
    0
};

char *probnoun[] = { /* a problem noun */
    "PRAABLUHM",	/* problem	*/
    "AEGRAHVEY2SHAXN",	/* aggravation	*/
    "BER2DEHN",		/* burden	*/
    "DIH2FIHKAXLTIY",	/* difficulty	*/
    "EHMBEH2RAHSMEHNT",	/* embarrasment	*/
    "FRAHSTREY2SHAHN",	/* frustration	*/
    "/HIHNDREHNS",	/* hindrance	*/
    "AABSTIHKAXL",	/* obstacle	*/
    "STAH2MBAXLIHNX BLAA1KQ",/* stumbling block	*/
    0
};
char *badadj[] = { /* derogatory adjectives */
    "IH3NKAHMPLIY2TDX",		/* incomplete	*/
    "AEBNOH3RMAXLX",		/* abnormal	*/
    "AHBRAH3PTDX",		/* abrupt	*/
    "AEBSER3D",			/* absurd	*/
    "AEBIH4ZMAHL",		/* abysmal	*/
    "AENAE3K/CROWNIH1STIHK",	/* anachronistic*/
    "AARKEY2IHK",		/* archaic	*/
    "BIHZAA3RX",		/* bizzare	*/
    "BRIY2F",			/* brief	*/
    "CHIY2PQX",			/* cheap	*/
    "KAHNFIYUW3ZTDX",		/* confused	*/
    "KAANVAHLUW2TDXEHTDX",	/* convoluted	*/
    "DIYFOH3RMTDX",		/* deformed	*/
    "DIHJEH3NAXREHTDX",		/* degenerate	*/
    "DEH3SPAXRXAHTDX",		/* desparate	*/
    "DIHSTRAH3KTDXIHVQV",	/* destructive	*/
    "DIHSKAH3STDXIHNX",		/* disgusting	*/
    "EHKSEH2NTRIHKQ",		/* eccentric	*/
    "FUWL/HAARXDIY",		/* foolhardy	*/
    "FYUW3TDXAXLX",		/* futile	*/
    "GRAE3NDIYOH2S",		/* grandiose	*/
    "GROWTDXEH3SK",		/* grotesque	*/
    "/HAEF BEYKDXQ",		/* half-baked	*/
    "IH3LX MAE1NEHJQD",		/* ill-managed	*/
    "IH3MAHCHUWRRX",		/* immature	*/
    "IHNAE3DEHKWAHTDX",		/* inadequate	*/
    "IH3NAHFEH3KDXCHUWAXL",	/* innefectual	*/
    "IHRAE3SHAHNAXL",		/* irrational	*/
    "IHREH3LAHVEHNTDX",		/* irrelevant	*/
    "LEY4TDX",			/* late		*/
    "LOW3DHQSAHM",		/* loathsome	*/
    "MAHLIH2GQNEHNTDX",		/* malignant	*/
    "MIH3NIHMAXL",		/* minimal	*/
    "MYUW3TDXIHLEY2TDXEHD",	/* mutilated	*/
    "MAYAA3PIK",		/* myopic	*/
    "NAAYIY3VV",		/* naive	*/
    "NYUWRAA3TDXIHK",		/* neurotic	*/
    "NAAN EHGZIH3STAHNTDX",	/* non-existent	*/
    "NAAN FAH3NXKSHAHNAXL",	/* non-functional*/
    "OWBIY3S",			/* obese	*/
    "AHBSEH3SIHV",		/* obsessive	*/
    "OW3VER AAPDXTIHMIH3SDXTIHK", /* over-optimistic */
    "PAEDXTRAHNAYZIHNX",	/* patronizing	*/
    "PERVER3TEHDXT",		/* perverted	*/
    "PAAMPAHS",			/* pompous	*/
    "PUH3RLIY TAYMTDX",		/* poorly-timed	*/
    "PRIYMAHDXCHER2",		/* premature	*/
    "PREHPAA3SDXTERAHS",	/* preposterous	*/
    "PRIH2MIHDXTIHV",		/* primitive	*/
    "RELAH3KTEHNTDX",		/* reluctant	*/
    "RUW3IHND",			/* ruined	*/
    "SHAELXOW",			/* shallow	*/
    "SIHLY",			/* silly	*/
    "SLAA3PIY",			/* sloppy	*/
    "SLAH3GIHSH",		/* sluggish	*/
    "SAA3RXIY",			/* sorry	*/
    "SDXTREH3IYNJ",		/* strange	*/
    "DXTWIH3STAXD",		/* twisted	*/
    "AH2NIHNTEH3LIHJIHBAXL",	/* unintelligible */
    "AH2NPAA3RDAXNAHBAXL",	/* unpardonable	*/
    "AH1NSTEYBAXL",		/* unstable	*/
    "YUW3SLAHS",		/* useless	*/
    "VAA3LAHTDXAXL",		/* volitile	*/
    "WER3THLAHS",		/* worthless	*/
    0
};

char *badnoun[] = { /* derogatory nouns */
    "DAA4KYAXMIXNTEY3SHEHN",	/* documentation*/
    "AA3RKIHTEH1KCHAHRX",	/* architecture	*/
    "BIY/HEY3VYER",		/* behavior	*/
    "BUW2TSTRXAEP",		/* bootstrap	*/
    "KOW5DD",			/* code		*/
    "KAXNSEH2PSHAHN",		/* conception	*/
    "DEY2TDXAH FLOW",		/* data flow	*/
    "DEY2TDXAH STRAHKCHERZ",	/* data structures */
    "DIHZAY2N",			/* design	*/
    "EHKWIH2PMEHNTDX",		/* equipment	*/
    "EH2RAHRX RIHKAH1VAXRXIY",	/* error recovery */
    "IHVAELIYUWEY2SHAHN",	/* evaluation	*/
    "FIY2CHERZ",		/* features	*/
    "FER3MWEHRX",		/* firmware	*/
    "/HAARDXWEHRX",		/* hardware	*/
    "IHMPLAHMEHNTEY3SHAXN",	/* implementation */
    "IHNTAHGREY2SHAXN",		/* integration	*/
    "IHNDXERFEYYSIXZ",		/* interfaces	*/
    "IHNTRAHDAH3KSHAXN",	/* introduction	*/
    "LAAJIHK",			/* logic	*/
    "MAE3NIHJMEHNTDX",		/* management	*/
    "MIY3DXIYAHAH",		/* media	*/
    "PAE2CHAXZ",		/* patches	*/
    "PLAE2NIHNX",		/* planning	*/
    "PRAA2SEHSAXRX",		/* processor	*/
    "RIYLAY3AHBIH2LIHTDXIY",	/* reliability	*/
    "SKEHJUWAXL",		/* schedule	*/
    "SAA2FTDXWEHRX",		/* software	*/
    "SPEHSIHFIHKEY2SHAXN",	/* specification*/
    "SAHPOH2RTDX",		/* support	*/
    "TEHKNAALEHJIY",		/* technology	*/
    0
};
